SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:10'!
bookFromEditorial
	
	^ 147896325! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 10:39'!
bookFromOtherEditorial
	
	^ 9283478920
! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/4/2013 13:53'!
cartWithBooks
	
	| cart |
	cart := self emptyCart .
	cart add: self bookFromEditorial.
	cart add: self bookFromEditorial.
	cart add: self bookFromEditorial.
	cart add: self otherBookFromEditorial .
	^ cart! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/5/2013 19:53'!
cashierWithEmptyCart
	^ Cashier
		withCart: self emptyCart
		creditCard: ''
		salesBook: ''
		andMerchantProcessor: nil! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/5/2013 19:53'!
cashierWithExpiredCreditCard
	^ Cashier
		withCart: self cartWithBooks
		creditCard: self expiredCreditCard
		salesBook: ''
		andMerchantProcessor: nil! !

!TusLibrosTest methodsFor: 'catalogue' stamp: 'FedericoMendez 6/4/2013 14:03'!
cataloge
	
	| aDictionary |
	aDictionary := Dictionary  new.
	aDictionary at: 147896325 put: 100.
	aDictionary at: 369874125 put: 150.
	aDictionary at: 9874563210 put: 280.
	aDictionary at: 172839465 put: 75.
	^ Cataloge withBooks: aDictionary.! !

!TusLibrosTest methodsFor: 'merchat processor' stamp: 'FedericoMendez 6/5/2013 20:29'!
creditCardWithInsuficientCredit

	^ [^ CreditCardWithInsuficientCredit signal]! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/11/2013 21:15'!
emptyCart
	| aCataloge |
	aCataloge := self cataloge.
	^ Cart fromClient: 'Pepe21' whichMustHaveBooksFrom: aCataloge! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 12:51'!
expiredCreditCard
	
	| expiredDate |
	expiredDate := Date today month previous previous .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !

!TusLibrosTest methodsFor: 'interface rest' stamp: 'FedericoMendez 6/12/2013 12:41'!
interfaceRest
	^ InterfaceRest withCataloge: self cataloge usersAndPasswordRegistered: self usersAndPasswords withSalesBook: nil! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:06'!
invalidNameCreditCard 

	^ CreditCard withNumber: '2854125469753125' withExpirationDate: (Date today month) propertyOf: 'A'! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:04'!
invalidNumberCreditCard 

	^ CreditCard withNumber: '2' withExpirationDate: (Date today month) propertyOf: 'Carlos Falso'! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:32'!
otherBookFromEditorial
	
	^ 369874125! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/5/2013 18:58'!
otherCartWithBooks
	
	| cart |
	cart := self otherEmptyCart .
	cart add: self bookFromEditorial.
	cart add: self otherBookFromEditorial .
	^ cart! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/5/2013 18:58'!
otherEmptyCart
	| aCataloge |
	aCataloge := self cataloge.
	^ Cart fromClient: '123456' whichMustHaveBooksFrom: aCataloge! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'FedericoMendez 6/5/2013 19:39'!
otherValidCreditCard
	
	| expiredDate |
	expiredDate := Date today month next next .
	^ CreditCard withNumber: '0000000000000001' withExpirationDate: expiredDate propertyOf: 'Juan Perez'! !

!TusLibrosTest methodsFor: 'merchat processor' stamp: 'FedericoMendez 6/5/2013 20:28'!
stolenCreditCard

	^ [^ StolenCreditCard signal]! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test01CartShouldBeEmptyWhenCreated 

	self assert: self emptyCart isEmpty .! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test02AddingABookFromOtherEditorialShouldRaiseCanNotAddABookFromOtherEditorialToTheCartException

	| cart book |
	cart := self emptyCart.
	book := self bookFromOtherEditorial.
	
	[cart add: book.
	self fail] on: Error do: [ :anError |
			self assert: cart isEmpty .
			self assert: anError class = CanNotAddABookFromOtherEditorialToTheCart ]! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test03AddingABookFromTheEditorialShouldAddItToTheCart

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: aCart booksQuantity = 1! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test04AddingABookFromTheEditorialTwiceShouldAddItToTheCartTwoTimes

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 2.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test05AddingTwoDifferentBooksShouldAddBothBooksToTheCart

	| aCart aBook otherBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	otherBook := self otherBookFromEditorial.
	aCart add: aBook.
	aCart add: otherBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: (aCart ocurrencesOf: otherBook) = 1.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:07'!
test06CreatingACreditCardWithAnInvalidNumberShouldRaiseCanNotCreateACreditCardWithAnInvalidNumberException 

	self should: [self invalidNumberCreditCard  ] raise: CanNotCreateACreditCardWithAnInvalidNumber! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:06'!
test07CreatingACreditCardWithAnInvalidNameShouldRaiseCanNotCreateACreditCardWithAnInvalidNameException 

	self should: [self invalidNameCreditCard ] raise: CanNotCreateACreditCardWithAnInvalidName ! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:12'!
test08AValidCreditCardCanBeCreated

	| number date owner creditCard |
	
	number := '7854236501495723'.
	date := Date today next next.
	owner := 'Juanito Mouse'.
	creditCard := CreditCard withNumber: number withExpirationDate: date propertyOf: owner.
	
	self assert: creditCard number = number.
	self assert: creditCard expirationDate = date.
	self assert: creditCard owner = owner 
	! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test09CreatingACashierWithAnEmptyCartShouldRaiseCanNotCreateACashierWithAnEmptyCartException

	self should: [self cashierWithEmptyCart ] raise: CanNotCreateACashierWithAnEmptyCart! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test10CreatingACashierWithAnExpiredCreditCardShouldRaiseCanNotCreateACashierWithAnExpiredCreditCardException

	self should: [self cashierWithExpiredCreditCard ] raise: CanNotCreateACashierWithAnExpiredCreditCard! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'FedericoMendez 6/5/2013 19:53'!
test11ACashierWithACartWithBooksAndAValidCreditCardCanBeCreated
	| cashier |
	cashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: nil
		andMerchantProcessor: nil.
	self assert: cashier cart = self cartWithBooks.
	self assert: cashier creditCard = self validCreditCard! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'FedericoMendez 6/4/2013 18:03'!
test12TheTotalAmountOfTheSaleShouldBeTheSumatoryOfThePricesOfEachBookInTheCart
	
	| cashier booksInCart amount |
	cashier := self validCashier .
	amount := 0.
	(cashier cart books) do: [:aBook | 
		amount := amount + (cashier cataloge priceOf: aBook)].
	
	self assert: cashier saleAmount = amount! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 20:27'!
test13AfterCheckOutTheSaleShouldBeRecordInTheSalesBook
	| salesBook cashier sale |
	salesBook := SalesBook new.
	cashier := Cashier withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction ) .
		
	self assert: salesBook isEmpty.
	sale := cashier checkOut.
	self deny: salesBook isEmpty.
	self assert: salesBook salesDone size = 1.
	self assert: (salesBook includes: sale)! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 20:27'!
test14AllSalesCheckedOutShouldAppearInTheSalesBook
	| salesBook cashier otherCashier sale notCheckedOutCashier aSale otherSale notCheckedOutSale |
	salesBook := SalesBook new.
	cashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction )  .
	otherCashier := Cashier
		withCart: self otherCartWithBooks
		creditCard: self otherValidCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction)  .
	notCheckedOutCashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction)  .
	aSale := cashier checkOut.
	otherSale := otherCashier checkOut.
	notCheckedOutSale := Sale from: notCheckedOutCashier.
	self assert: ((salesBook salesOfTheClient: cashier client) includes: aSale).
	self assert: ((salesBook salesOfTheClient: otherCashier client) includes: otherSale).
	self deny: ((salesBook salesOfTheClient: otherCashier client) includes: notCheckedOutSale).
	self assert: salesBook salesDone size = 2! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 20:27'!
test15TheTotalAmountSpentByAClientIsTheSumOfTheAmountsOfAllHisPurchases
	| salesBook cashier otherCashier sale notCheckedOutCashier aSale otherSale notCheckedOutSale |
	salesBook := SalesBook new.
	cashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction)  .
	otherCashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction)  .
	aSale := cashier checkOut.
	otherSale := otherCashier checkOut.
	self assert: (salesBook totalSpentBy: cashier client) = (aSale saleAmount + otherSale saleAmount)! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 20:24'!
test16CheckingOutWithAStolenCreditCardShouldRaiseStolenCreditCardExceptionAndSaleWontBeDone

	| cashier salesBook |
	
	salesBook := SalesBook new.
	cashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self stolenCreditCard) .
		
	[cashier checkOut .
	 self fail.] on: Error do: [ :anError |
			self assert: salesBook isEmpty .
			self assert: anError class = StolenCreditCard]! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 20:29'!
test17CheckingOutWithACreditCardWithInsuficientCreditShouldRaiseCreditCardWithInsuficientCreditExceptionAndSaleWontBeDone

	| cashier salesBook |
	
	salesBook := SalesBook new.
	cashier := Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: salesBook
		andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self creditCardWithInsuficientCredit) .
		
	[cashier checkOut .
	 self fail.] on: Error do: [ :anError |
			self assert: salesBook isEmpty .
			self assert: anError class = CreditCardWithInsuficientCredit ]! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 21:30'!
test18creatingACartShouldReturnTheCartIDWhichRepresentsTheCartCreated

	| interfaceRest anUser aPassword cartID |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Juan21' withPassword: '1234'.
	
	self assert: (interfaceRest cartWithID: cartID) = (Cart fromClient: 'Juan21' whichMustHaveBooksFrom: self cataloge) .! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 23:15'!
test19CanNotCreateACartFromAnInvalidUserAndShouldRaiseInvalidUserOrPasswordException

	| interfaceRest anUser aPassword cartID |
	interfaceRest := self interfaceRest .
	
	self should: [cartID := interfaceRest createCartToUser: 'Carlitos' withPassword: 'trucho'] raise: InvalidUserOrPassword ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 23:15'!
test20CanNotCreateACartFromAnInvalidPasswordAndShouldRaiseInvalidUserOrPasswordException

	| interfaceRest anUser aPassword cartID |
	interfaceRest := self interfaceRest .
	self should: [cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'malPasswd'] raise: InvalidUserOrPassword ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 22:34'!
test21TwoDifferentUsersShouldHaveDifferentCartID

	| interfaceRest  cartID otherCartID |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Juan21' withPassword: '1234'.
	otherCartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	
	self deny: cartID = otherCartID ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 22:49'!
test22AddingABookShouldAddTheBookToTheCart

	| interfaceRest anUser aPassword cartID aBookISBN |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 4.
	
	self assert: ( (interfaceRest cartWithID: cartID) ocurrencesOf: aBookISBN) = 4! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 23:14'!
test23CanNotAddABookToAInvalidCartAndShouldRaiseInvalidCartException

	| interfaceRest anUser aPassword cartID aBookISBN |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	self should: [interfaceRest addToCart: 5 theBook: aBookISBN quantity: 4] raise: InvalidCart ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/11/2013 23:13'!
test24CanNotAddABookWithAQuantityLowerThan1ToTheCartAndShouldRaiseInvalidBookQuantityException

	| interfaceRest anUser aPassword cartID aBookISBN |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	
	self should: [interfaceRest addToCart: cartID theBook: aBookISBN quantity: -5] raise: InvalidBookQuantity! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:08'!
test25ListCartShouldReturnTheBooksInTheCart

	| interfaceRest anUser aPassword cartID aBookISBN otherBookISBN booksBag |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	otherBookISBN := self otherBookFromEditorial .
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	interfaceRest addToCart: cartID theBook: otherBookISBN quantity: 5.
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	
	
	self assert: ( (interfaceRest listCart: cartID) size) = 11.
	self assert: ( (interfaceRest listCart: cartID) occurrencesOf: aBookISBN) = 6.
	self assert: ( (interfaceRest listCart: cartID) occurrencesOf: otherBookISBN) = 5.! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:09'!
test26CanNotListCartWithAnInvalidCartIDAndShouldRaiseInvalidCartException

	| interfaceRest anUser aPassword cartID aBookISBN otherBookISBN booksBag |
	interfaceRest := self interfaceRest .
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	otherBookISBN := self otherBookFromEditorial .
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	interfaceRest addToCart: cartID theBook: otherBookISBN quantity: 5.
	
	self should: [interfaceRest listCart: 0] raise: InvalidCart ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:09'!
test27CheckingOutShouldMakeTheTransactionAndReturnTheTransactionID

	| interfaceRest cartID aBookISBN otherBookISBN transactionID creditCard cashier |
	interfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook: SalesBook new.
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	aBookISBN := self bookFromEditorial .
	otherBookISBN := self otherBookFromEditorial .
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	interfaceRest addToCart: cartID theBook: otherBookISBN quantity: 5.
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	
	transactionID := interfaceRest checkOutCart: cartID withCreditCardNumber: '9600000000000000' withExpiration: (Date today month next) fromClient: 'Inspector Archundia' 
		withMerchatnProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
		
	creditCard := CreditCard withNumber: '9600000000000000' withExpirationDate: (Date today month next) propertyOf: 'Inspector Archundia'  .
	cashier := Cashier withCart: ( interfaceRest cartWithID: cartID ) creditCard: creditCard  salesBook: SalesBook new andMerchantProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
	self assert: ( interfaceRest saleWithTransactionID: transactionID ) = (Sale from: cashier) . ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:09'!
test28CheckingOutTwoTransactionsShouldReturnDifferentTransactionID

	| interfaceRest cartID aBookISBN otherBookISBN transactionID creditCard cashier aSalesBook otherInterfaceRest otherCartID otherTransactionID otherCashier |
	aSalesBook := SalesBook new.
	interfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook:  aSalesBook.
	otherInterfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook: aSalesBook.
	
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	otherCartID := otherInterfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	
	aBookISBN := self bookFromEditorial .
	otherBookISBN := self otherBookFromEditorial .
	
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	interfaceRest addToCart: cartID theBook: otherBookISBN quantity: 5.
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	
	otherInterfaceRest addToCart: otherCartID theBook: aBookISBN quantity: 10.
	otherInterfaceRest addToCart: otherCartID theBook: otherBookISBN quantity: 4.	
	
	transactionID := interfaceRest checkOutCart: cartID withCreditCardNumber: '9600000000000000' withExpiration: (Date today month next) fromClient: 'Inspector Archundia' 
		withMerchatnProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
	otherTransactionID := interfaceRest checkOutCart: cartID withCreditCardNumber: '9600000000000000' withExpiration: (Date today month next) fromClient: 'Inspector Archundia' 
		withMerchatnProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
	self deny: transactionID = otherTransactionID ! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:09'!
test29ListPurchasesShouldReturnThePurchasesDoneByTheUser

	| interfaceRest cartID aBookISBN otherBookISBN transactionID creditCard cashier aSalesBook otherInterfaceRest otherCartID otherTransactionID otherCashier purchasesOfUser purchasesOfUserFromOtherInterface |
	aSalesBook := SalesBook new.
	interfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook:  aSalesBook.
	otherInterfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook: aSalesBook.
	
	cartID := interfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	otherCartID := otherInterfaceRest createCartToUser: 'Pepe' withPassword: 'passwd'.
	
	aBookISBN := self bookFromEditorial .
	otherBookISBN := self otherBookFromEditorial .
	
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	interfaceRest addToCart: cartID theBook: otherBookISBN quantity: 5.
	interfaceRest addToCart: cartID theBook: aBookISBN quantity: 3.
	
	otherInterfaceRest addToCart: otherCartID theBook: aBookISBN quantity: 10.
	otherInterfaceRest addToCart: otherCartID theBook: otherBookISBN quantity: 4.	
	
	transactionID := interfaceRest checkOutCart: cartID withCreditCardNumber: '9600000000000000' withExpiration: (Date today month next) fromClient: 'Inspector Archundia' 
		withMerchatnProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
	otherTransactionID := interfaceRest checkOutCart: cartID withCreditCardNumber: '9600000000000000' withExpiration: (Date today month next) fromClient: 'Inspector Archundia' 
		withMerchatnProcessor: (PluggableMerchantProcessor whichEvaluates: self validTransaction) .
		
	purchasesOfUser := interfaceRest listPurchasesOf: 'Pepe' withPassword: 'passwd'.
	purchasesOfUserFromOtherInterface := otherInterfaceRest listPurchasesOf: 'Pepe' withPassword: 'passwd'.
	
	self assert: purchasesOfUser = purchasesOfUserFromOtherInterface .
	self assert: purchasesOfUser size = 2.! !

!TusLibrosTest methodsFor: '5 - Test InterfaceRest' stamp: 'FedericoMendez 6/12/2013 15:10'!
test30CannotListPurchasesWithAnInvalidUserOrPassword

	| interfaceRest aSalesBook |
	
	aSalesBook := SalesBook new.
	interfaceRest := InterfaceRest withCataloge: (self cataloge) usersAndPasswordRegistered: (self usersAndPasswords) withSalesBook:  aSalesBook.

	self should: [interfaceRest listPurchasesOf: 'UnknownUser' withPassword: 'passwd' ] raise: InvalidUserOrPassword  
! !

!TusLibrosTest methodsFor: 'interface rest' stamp: 'FedericoMendez 6/11/2013 21:28'!
usersAndPasswords

	| dictionary |
	dictionary := Dictionary new.
	dictionary at: 'Pepe' put: 'passwd'.
	dictionary at: 'Juan21' put: '1234'.
	^ dictionary 
	
	! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/5/2013 19:53'!
validCashier
	^ Cashier
		withCart: self cartWithBooks
		creditCard: self validCreditCard
		salesBook: ''
		andMerchantProcessor: nil! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:07'!
validCreditCard
	
	| expiredDate |
	expiredDate := Date today month next next .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !

!TusLibrosTest methodsFor: 'merchat processor' stamp: 'FedericoMendez 6/5/2013 20:28'!
validTransaction
	
	[]! !

Error subclass: #CanNotAddABookFromOtherEditorialToTheCart
	instanceVariableNames: 'book'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnEmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnExpiredCreditCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CreditCardWithInsuficientCredit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #InvalidBookQuantity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #InvalidCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #InvalidUserOrPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #StolenCreditCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'books cataloge clientID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:55'!
fromClient: aClientID whichMustHaveBooksFrom: aCataloge
	^ self new fromClient: aClientID whichMustHaveBooksFrom: aCataloge! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
= aCart

	^ books = aCart books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:04'!
add: aBook 

	(cataloge includes: aBook) ifFalse: [^ CanNotAddABookFromOtherEditorialToTheCart  signal].
	books add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
books

	^ books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
booksQuantity
	
	^ books size! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
cataloge

	^ cataloge! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:57'!
client
	
	^ clientID ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:55'!
fromClient: aClientID whichMustHaveBooksFrom: aCataloge
	
	clientID := aClientID.
	cataloge := aCataloge ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
initialize 
	
	books := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:19'!
isEmpty 

	^ books isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
ocurrencesOf: aBook

	^ books occurrencesOf: aBook ! !

Object subclass: #Cashier
	instanceVariableNames: 'cart creditCard cataloge amountOfSale salesBook merchatProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:08'!
withCart: aCart creditCard: aCreditCard salesBook: aSalesBook andMerchantProcessor: aMerchatProcessor 
	aCart isEmpty
		ifTrue: [ ^ CanNotCreateACashierWithAnEmptyCart signal ].
	aCreditCard isExpired
		ifTrue: [ ^ CanNotCreateACashierWithAnExpiredCreditCard signal ].
	^ self new
		withCart: aCart
		creditCard: aCreditCard
		salesBook: aSalesBook
		andMerchantProcessor: aMerchatProcessor! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:57'!
books
	
	^ cart books! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:38'!
cart

	^ cart! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:17'!
cataloge

	^ cataloge! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:08'!
checkOut
	
	| sale |
	sale := Sale from: self.
	merchatProcessor debit: sale saleAmount from: creditCard .
	salesBook add: sale.
	^ sale! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:56'!
client
	
	^ cart client! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
creditCard

	^ creditCard! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:25'!
saleAmount
	
	^ amountOfSale ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:08'!
withCart: aCart creditCard: aCreditCard salesBook: aSalesBook andMerchantProcessor: aMerchatProcessor 
		
	cart := aCart .
	creditCard := aCreditCard .
	cataloge := aCart cataloge.
	salesBook := aSalesBook .
	merchatProcessor := aMerchatProcessor .

	amountOfSale := 0.
	(aCart books) do: [ :aBook | 
		amountOfSale := amountOfSale + (aCart cataloge priceOf: aBook) ]! !

Object subclass: #Cataloge
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cataloge class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 11:20'!
withBooks: aSet 
	
	^ self new withBooks: aSet! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
includes: aBook
	
	^ books includesKey: aBook ! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:14'!
priceOf: aBook 
	
	^ books at: aBook ! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
withBooks: aDictionary  
	
	books := aDictionary .! !

Object subclass: #CreditCard
	instanceVariableNames: 'number expirationDate owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:03'!
withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	(aNumber isAllDigits and: aNumber size = 16) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidNumber signal].
	(anOwner size > 3) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidName signal].
	^ self new withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:42'!
= aCreditCard 

	^ number = aCreditCard number and: (owner = aCreditCard owner and: expirationDate = aCreditCard expirationDate )! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
expirationDate

	^ expirationDate! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
isExpired
	
	^ Date today month > expirationDate ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:11'!
number

	^ number! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
owner

	^ owner! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
withNumber: aLargePositiveInteger withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	number := aLargePositiveInteger .
	expirationDate := anExpirationDate .
	owner := anOwner ! !

Object subclass: #InterfaceRest
	instanceVariableNames: 'cartsDicionary catalogue usersAndPasswords salesBook salesDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!InterfaceRest class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 12:46'!
withCataloge: aCataloge usersAndPasswordRegistered: aDictionary withSalesBook: aSalesBook
	^ self new withCataloge: aCataloge usersAndPasswordRegistered: aDictionary withSalesBook: aSalesBook! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/11/2013 23:01'!
addToCart: aCartID theBook: aBookISBN quantity: aQuantity 

	| cart |
	(aQuantity < 1) ifTrue: [InvalidBookQuantity signal].
	[ cart := cartsDicionary at: aCartID ] on: KeyNotFound do: [InvalidCart signal].
	(1 to: aQuantity) do: 
		[ :n | cart add: aBookISBN ]! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/11/2013 21:24'!
cartWithID: aCartID 
	
	^ cartsDicionary at: aCartID ! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 12:28'!
checkOutCart: aCartID withCreditCardNumber: aCreditCardNumber withExpiration: anExpirationDate fromClient: aCreditCardName withMerchatnProcessor: aMerchatProcessor
	
	| creditCard cashier sale |
	creditCard := CreditCard withNumber: aCreditCardNumber withExpirationDate: anExpirationDate propertyOf: aCreditCardName .
	cashier := Cashier withCart: (self cartWithID: aCartID ) creditCard: creditCard  salesBook: salesBook andMerchantProcessor: aMerchatProcessor .
	sale := cashier checkOut.
	salesDictionary at: (sale hash) put: sale.
	^ sale hash.! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/11/2013 22:11'!
createCartToUser: aName withPassword: aPassword 
	
	| cart id passwd |
	
	[passwd := usersAndPasswords at: aName ] on: KeyNotFound do: [InvalidUserOrPassword signal].
	(passwd = aPassword) ifFalse: [InvalidUserOrPassword signal].

	cart := Cart fromClient: aName whichMustHaveBooksFrom: catalogue.
	id := cart hash.
	cartsDicionary at: id put: cart.
	^ id! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 12:39'!
initialize 

	cartsDicionary := Dictionary new.
	salesDictionary := Dictionary new.! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/11/2013 23:10'!
listCart: aCartID 
	
	| cart |
	[ cart := cartsDicionary at: aCartID ] on: KeyNotFound do: [InvalidCart signal].
	^ cart books.! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 13:02'!
listPurchasesOf: aName withPassword: aPassword  
	
	| passwd |
	[passwd := usersAndPasswords at: aName ] on: KeyNotFound do: [InvalidUserOrPassword signal].
	(passwd = aPassword) ifFalse: [InvalidUserOrPassword signal].
	
	^ salesBook salesOfTheClient: aName ! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 12:36'!
saleWithTransactionID: aTransactionID
 
	^ salesDictionary at: aTransactionID ! !

!InterfaceRest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/12/2013 12:41'!
withCataloge: aCataloge usersAndPasswordRegistered: aUsersAndPasswordsDictionary withSalesBook: aSalesBook 
	
	catalogue := aCataloge .
	usersAndPasswords := aUsersAndPasswordsDictionary.
	salesBook := aSalesBook.! !

Object subclass: #PluggableMerchantProcessor
	instanceVariableNames: 'number expirationDate owner evaluation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PluggableMerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:23'!
whichEvaluates: aBlock 
	
	^ self new whichEvaluates: aBlock! !

!PluggableMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:24'!
debit: anAmout from: aCreditCard

	evaluation value! !

!PluggableMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 20:23'!
whichEvaluates: aBlock 
	
	evaluation := aBlock! !

Object subclass: #Sale
	instanceVariableNames: 'clientID saleAmount booksSold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:23'!
from: aCashier 

	^ self new from: aCashier ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:32'!
= aSale

	^ clientID = aSale client and: (saleAmount = aSale saleAmount and: booksSold = aSale booksSold )! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
booksSold 

	^ booksSold ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
client

	^ clientID .! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:25'!
from: aCashier 
	
	clientID := aCashier client .
	saleAmount := aCashier saleAmount .
	booksSold := aCashier books .! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
saleAmount 

	^ saleAmount .! !

Object subclass: #SalesBook
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:26'!
add: aSale 
	
	sales add: aSale ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:27'!
includes: aSale 

	^ sales includes: aSale ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 19:10'!
initialize 

	sales := OrderedCollection new.! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:23'!
isEmpty
	
	^ sales isEmpty .! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 19:11'!
salesDone
	
	^ sales! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 19:10'!
salesOfTheClient: aClient
	
	| totalSales salesOfTheClient |
	
	salesOfTheClient := Set new .
		
	sales do: [ :aSale | (aSale client  = aClient) ifTrue: [ salesOfTheClient add: aSale] ] .
	
	^ salesOfTheClient ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 19:14'!
totalSpentBy: aClient 

	| salesOfTheClient total |
	
	salesOfTheClient := self salesOfTheClient: aClient .
	total := 0 .
	sales do: [ :aSale | total := total + aSale saleAmount  ] .
	^ total! !
